#!/usr/bin/perl
if($ARGV[0] eq "h"){
printf("USAGE: perl lwg.pl RLS_FL <DBG>\n");
printf("RLS_FL : path of the rls fl\n");
printf("DBG : optional parameter : value : 1/0\n");
exit(0);
}
$DEBUG = 0;
$DEBUG = $ARGV[1];
$FL = $ARGV[0];
#
#### READ THE TABLE OF RULES
#
open(RLS,"<$FL") || die "file rls not found\n";
@rls = <RLS>;
close(RLS,"rls");
$size_of_rls = $#rls+1;
if($DEBUG) {
print "Read the table of Rules\n";
print "Total size_of_rls =",$#rls,"\n";
}
#
#### SPLIT DIFF FIELDS
#
for($i = 4;$i<$size_of_rls;$i++)
{
chop($rls[$i]);
($rl_no[$i-4],$wrds_to_be_grpd[$i-4],@mo_ana) = split(/	/,$rls[$i]);
for($j = 0;$j<$wrds_to_be_grpd[$i-4];$j++)
{
$old_mo_ana[($i-4)*5+$j] = $mo_ana[$j]; # $old_mo_ana size assumed to be [][5]
$new_mo_ana[($i-4)*5+$j] = $mo_ana[$j+$wrds_to_be_grpd[$i-4]];# $old_mo_ana size assumed to be [][5]
}
}
if($DEBUG){
for($i=0;$i<2;$i++){
print $rl_no[$i],"\n";
for($j=0;$j<5;$j++){
print $old_mo_ana[$i*5+$j]," ";
}
for($j=0;$j<5;$j++){
print $new_mo_ana[$i*5+$j]," ";
}
print "\n";
}
}
#
### MAIN FUNCTION STARTS
#
$/ = "\n\n"; # Read a paragraph
#$/ = ".";
#For each paragraph, store the morph analysis  & the spaces in global
#arrays ana[$i],spc[$i]
while($in = <STDIN>)
{
$in =~ s/_OUT/_OUT#/g;
$in =~ s/_FRZ/_FRZ#/g;
$in =~ s/OUT_/#OUT_/g;
$in =~ s/FRZ_/#FRZ_/g;
$in =~ s/_LWG/_LWG#/g;
$in =~ s/LWG_/#LWG_/g;
$in =~ s/_MO/_MO#/g;
$in =~ s/MO_/#MO_/g;
$in =~ s/##/#/g;
$i=0;
#while($in =~ /([ 	^\n]*)#_([^#]*)_#/g)
while($in =~ /([ 	_#^\n]*)([^#]*)/g) {
$spc[$i] = $1;
$ana[$i] = $2;
$mo_flag[$i] = 0;
if($ana[$i] =~ /MO_/) { $ana[$i] =~ s/MO_//;}
if($ana[$i] =~ /_MO/) { $ana[$i] =~ s/_MO//;$mo_flag[$i] = 1;}
#$ana[$i] =~ s/_$//;
if($DEBUG){
print $i,"=",$spc[$i],$ana[$i],"\n";
print $mo_flag[$i],"\n";
}
$i++;
}
$cnt = $i;
if($DEBUG) { print "TOTAL WRDS IN PARAGRAPH = $cnt\n";}
$i = 0;
while($i < $cnt)
{
if(($ana[$i] !~ /{[a-zA-Z\?_]* [nPv] /) && ($ana[$i] !~ /Avy/)) {
#print "1",$spc[$i],$ana[$i],"\n";
if($DEBUG){ print "\n";}
print $spc[$i],$ana[$i];
$i++;
}
else { 
$ana[$i] =~ s/#_//;
$ana[$i] =~ s/_#//;
$wrds_to_be_grpd = &chk_lwg_case($i) ;
if($DEBUG) {print "WRDS TO BE GRPD = $wrds_to_be_grpd \n";}
if($wrds_to_be_grpd == 1) {
print $spc[$i];
if($mo_flag[$i]) { print "MO_";}
print $ana[$i];
if($mo_flag[$i]) { print "_MO";}
}
else{
for($j = 0; $j < $wrds_to_be_grpd; $j++){
if($ana[$i+$j] !~ /LWG/){
print $spc[$i+$j],"LWG_",$ana[$i+$j],"_LWG";
}
else{
if($mo_flag[$i]) { print "MO_";}
print $spc[$i+$j],$ana[$i+$j];
if($mo_flag[$i]) { print "_MO";}
}
}
}
$i = $i + $wrds_to_be_grpd;
if($DEBUG) { print "i incremented to $i \n";}
}
}
#if($cnt > 0) {print "\n";}
#print "\n\n";
}
sub chk_lwg_case
{
local($k) = @_;
local($i,$j);
if($DEBUG) { print "Calling chk_lwg_case with i = $k\n";}
$flag = 0;
for($i = 0; ($i<$size_of_rls-4) && !$flag; $i++) {
$flag = 1;
#if($DEBUG){
#print $ana[$k+$j],"==",$old_mo_ana[$i*5+$j]," ",$wrds_to_be_grpd[$i],"\n";
#}
for($j=0; ($j<$wrds_to_be_grpd[$i]) && $flag; $j++){
if($DEBUG){
print $ana[$k+$j],"==",$old_mo_ana[$i*5+$j],"\n";
}
if($ana[$k+$j] =~ /$old_mo_ana[$i*5+$j]/) { $flag = 1;}
else { $flag = 0;}
if($DEBUG){
print $flag,"\n";
}
}
if($flag) { 
if($DEBUG) { print "ALL conditions of rule $rl_no[$i] are satisfied \n";}
for($j=0; $j<$wrds_to_be_grpd[$i]; $j++){
if($new_mo_ana[$i*5+$j] eq "---"){
if($DEBUG) { print $new_mo_ana[$i*5+$j]; }
$ana[$k+$j] = $new_mo_ana[$i*5+$j];
}
else{
$ana[$k+$j] =~ s/^[^\/]*\/([^\/]*)($old_mo_ana[$i*5+$j])([^\/]*)/\1\2\3/;
$ana[$k+$j] =~ s/^.*\/([^\/]*)($old_mo_ana[$i*5+$j])([^\/]*)/\1\2\3/;
$ana[$k+$j] =~ s/([^\/]*)($old_mo_ana[$i*5+$j])([^\/]*)\/.*/\1\2\3/;
$ana[$k+$j] =~ s/$old_mo_ana[$i*5+$j]/$new_mo_ana[$i*5+$j]/;
$ana[$k+$j] =~ s/^([^])/\1/;
}
if($DEBUG){
print $ana[$k+$j],"\n";
}
}
$incr = $wrds_to_be_grpd[$i];
}
else{
$incr = 1;
}
}
$incr;
}
1;
