/* 
PURPOSE : To convert gender , number , person from character string to numbers and vice versa.
Within a program all gender , number and person are treated as numbers.
It is only when they are stored/displayed,they are converted to strings.
*/
#include <stdio.h>
#include<string.h>
#include "/home/bharathi/TESTKND/anusAraka/com/lwg/prog/headers/defn.h"
#include "/home/bharathi/TESTKND/anusAraka/com/lwg/prog/headers/struct.h"
#include "/home/bharathi/TESTKND/anusAraka/com/lwg/prog/headers/glbl.h"

extern int VSMT;
extern FILE *fp_err;

conv_gen(gen)
char gen;
{
switch(gen)
{
case 'm':return(MASCULINE);
case 'f':return(FEMININE);
case 'n':return(NEUTER); /* in HINDI no neuter gender */
case 'a':return(MASCULINE*FEMININE); /* in case of HINDI */
}
}
conv_num(num)
char num;
{
switch(num)
{
case 's':return(SINGULAR);
case 'p':return(PLURAL);
case 'a':return(SING_PLRL);
}
}
conv_per(per)
char per[PERSON];
{
switch(per[0])
{
case 'u':return(UTTAM);
case 'm':return(MADHYAM);
case 'a':switch(per[1])
	 { 
	 case 'n':return(UTTAM*MADHYAM*ANYA);/* in case of 'any' next character is n */
	 default :return(ANYA);
	 }
}
}
void
conv_s_gen(gen,gen_s)
int gen;
char *gen_s;
{
switch(gen)
{
case MASCULINE :strcpy(gen_s,"m");break;
case FEMININE : strcpy(gen_s,"f");break;
case NEUTER : strcpy(gen_s,"n");break;
case MASCULINE * FEMININE : strcpy(gen_s,"any");break; /* in case of HINDI */
default :strcpy(gen_s , "any");break;
}
}
void
conv_s_num(num,num_s)
int num;
char *num_s;
{
switch(num)
{
case SINGULAR: strcpy(num_s,"s");break;
case PLURAL: strcpy(num_s ,"p");break;
case SING_PLRL: strcpy(num_s ,"any");break;
default :strcpy(num_s , "any");break;
}
}
void
conv_s_per(per,per_s)
int per;
char *per_s;
{
switch(per)
{
case UTTAM: strcpy(per_s ,"u");break;
case MADHYAM: strcpy(per_s ,"m");break;
case ANYA: strcpy(per_s ,"a");break;
case UTTAM * MADHYAM : strcpy(per_s , "u_m");break;
case UTTAM * ANYA : strcpy(per_s , "u_a");break;
case MADHYAM * ANYA : strcpy(per_s , "m_a");break;
case UTTAM * MADHYAM * ANYA : strcpy(per_s , "any");break;
default : strcpy(per_s,"");break;
}
}
conv_cas(cas)
char *cas;
{
if((cas[1] != '\0') && VSMT) 
           {
           fprintf(fp_err,"%s case not covered ; prime() will also need modification if you add new cases\n",cas);
           print_status(CURRNT_WRD);
	   return(CASE_ZERO);
           }
switch(cas[0])
{
case '0':return(CASE_0);
case '1':return(CASE_1);
case '2':return(CASE_2);
case '3':return(CASE_3);
case '4':return(CASE_4);
case '5':return(CASE_5);
case '6':return(CASE_6);
case '7':return(CASE_7);
case '8':return(CASE_8);
case '9':return(CASE_9);
}
}
void
conv_s_cas(cas,cas_s)
int cas;
char *cas_s;
{
switch(cas)
{
case CASE_0 :strcpy(cas_s,"0");break;
case CASE_1 :strcpy(cas_s,"1");break;
case CASE_2 :strcpy(cas_s,"2");break;
case CASE_3 :strcpy(cas_s,"3");break;
case CASE_4 :strcpy(cas_s,"4");break;
case CASE_5 :strcpy(cas_s,"5");break;
case CASE_6 :strcpy(cas_s,"6");break;
case CASE_7 :strcpy(cas_s,"7");break;
case CASE_8 :strcpy(cas_s,"8");break;
case CASE_9 :strcpy(cas_s,"9");break;
case CASE_ZERO :strcpy(cas_s,"");break;
default : fprintf(stderr,"CASE NOT COVERED : conv_s_cas()\n");
}
}
