%{
#define RELOP 00
#define LT    01
#define LE    02
#define EQ    03
#define NE    04
#define GT    05
#define GE    06
#define IF    10
#define THEN  11
#define ELSE  12
#define ID    21
#define NUMBER 22
  
#include"symbol.h"
static symbol *symlist = 0;
%}

delim		[ \t\n]
ws		{delim}+
if		"if"
then		"then"
else		"else"
letter		[A-Za-z]
digit		[0-9]
id		{letter}({letter}|{digit})*
number          {digit}+(\.{digit}+)?(E[+|-]?{digit}+)?
%%
{ws}		;
{if}		{return(IF);}
{then}		{return(THEN);}
{else}		{return(ELSE);}
{id}		{yylval = install_id(); return(ID);}
{number}	{yylval = install_num();return(NUMBER);}
"<"		{yylval = LT ; return(RELOP);}
"<="		{yylval = LE ; return(RELOP);}
"="		{yylval = EQ ; return(RELOP);}
"<>"		{yylval = NE ; return(RELOP);}
">"		{yylval = GT ; return(RELOP);}
">="		{yylval = GE ; return(RELOP);}
%%
install_id()
{
symbol *s;
if((s=lookup(yytext)) == 0)
   s = install(yytext);
}

symbol *lookup(s)
char *s;
{
symbol *sp;
for (sp = symlist ; sp != (symbol)*0;sp=sp->next)
    if(strcmp(sp->name,s) == 0)
     return sp;
return 0;
}

symbol *install(s)
char *s;
{
symbol *sp;
sp = (symbol *) malloc(sizeof(symbol));
sp->name = malloc(strlen(s)+1);
strcpy(sp->name,s);
sp->next = symlist;
symlist = sp;
return sp;
}

install_num()
{
symbol *s;
s = install(yytext);
return(s);
}

yywrap()
{
}
