# This program converts a file from one roman notation to another Roman Notation.
# The words that start with @ are not converted.
# Input : a table of conversion in the following form
# symbol in one roman notation,symbol in another roman notation
# E.G. sample entries for BH Krishnamurthy's notation to IITK Notation:
#a,a
#a,A
#i,i
#ii,I

# Usage : perl cnvrt_tab.pl tab < input_file > output_file
# tab : conversion table file name
# input_file : a file in one roman notation
# output file : conversion of input-file into another notation
# Note : words that start with @ are not converted.

# Read the table & form an associative array.

#print "AAAA",$ARGV[0],"\n";
#$fl_name = $ARGV[0];
#open($TABLE,"$fl_name");
open(TABLE,"$ARGV[0]") || die " Unable to open $ARGV[0]\n";
$max = 0;
while($in = <TABLE>)
{
#print $in;
chop($in);
($key1 ,$val1)=split(/,/,$in);
$tab{$key1} = $val1;
if($max < length($key1)) { $max = length($key1);}
}
close(TABLE);

# find out the maximum look-ahead.

#print $max,"\n";
$look_ahead = $max;
#print $look_ahead,"\n";
#foreach $key ( keys %tab)
#{
#print $key , " " ,$tab{$key},"\n";
#}

# flush the buffer
$| = 1;

while($in = <STDIN>)
{
#print $in,"\n";
chop($in);
#@words = split(/\b/, $in);
$count = -1;
if($in =~ /./){
	while($in =~ m/([	 ]*)([^ 	]*)/g) {
		$count++;
		$preceding_white_space[$count] = $1;	
		$words[$count] = $2;	
		}
        }
#@words = split(/[ \t\n\r]/, $in);
#foreach $word (@words)
$i=0;
while($i <= $count){
print $preceding_white_space[$i];
$word = $words[$i];
#print "1",$word,"\n";
if(length($word) >= $look_ahead) #check whether there are enough words in the word.
{$cur_look_ahead = $look_ahead;}
else {$cur_look_ahead = length($word);}
while(($word =~ /./) && ($word !~ /^@/))
{
if($word =~ /^(.{$cur_look_ahead})(.*)$/)
{
$context = $1;
$rem = $2;
#print "3",$context,"4",$rem,"5\n";
if($tab{$context} ne "") { 
print $tab{$context};
$word = $rem;
if(length($word) >= $look_ahead) 
{$cur_look_ahead = $look_ahead;}
else {$cur_look_ahead = length($word);}
#$cur_look_ahead = $look_ahead;
}
else { 
if($cur_look_ahead > 1) # match the subset of chars., if match is not found for given set of chars.
{
$cur_look_ahead = $cur_look_ahead-1;
}
else { #look-ahead equal to 1  & no map is found in assosiative array.
#In this case map the charatcter as it is.
print $context;
$word = $rem;
if(length($word) >= $look_ahead) 
{$cur_look_ahead = $look_ahead;}
else {$cur_look_ahead = length($word);}
}
}
}
else { print $word; $word = "";}
}
#Do not process the word if it starts with @
if ($word =~ /^@/) { print $word;}
#print $cur_look_ahead,"\n",$word;
#print " ";
$i++;
}
#print "1",$context,"2\n";
print "\n"; # restore the chopped char.It is assumed that \n is the chopped char. 
}
